.proc start_object_spawner
  rep #$30	;A=16, X/Y=16
  ldx #$0000

object_spawner_loop:
  lda a:ObjectTable,x
  beq object_spawner_loop_done
  txa
  clc
  adc #ObjectTableEntrySize
  tax
  cpx #ObjectTableSize
  bne object_spawner_loop

object_spawner_loop_done:
  lda a:NewObjectRequest
  sta a:ObjectTable,x
  rts
.endproc

;====================================================================================
.proc start_object_identifier
  rep #$30    ;A=16, X/Y=16
  lda #ObjectTable
  sta a:ObjectOffset
  tcd

object_identifier_loop:
  lda $0000
  beq next_object
  tax
  jsr (ObjectIdentificationJumpTable-2,x)
  rep #$30	;A=16, X/Y=16

next_object:
  lda a:ObjectOffset
  clc
  adc #ObjectTableEntrySize
  sta a:ObjectOffset
  tcd
  cmp #ObjectTable+ObjectTableSize
  bne object_identifier_loop

  jsr start_process_oam

  jsr start_metasprite
  rts
.endproc

;=========================================================================================
.segment "RODATA"
;========================================================================

ObjectIdentificationJumpTable:
  .word object1_code